#include <SPI.h>
#include <Mirf.h>
#include <nRF24L01.h>
#include <MirfHardwareSpiDriver.h>
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27,16,2);  // set the LCD address to 0x27 for a 16 chars and 2 line display

void setup()
{
  Serial.begin(9600);
  Mirf.spi = &MirfHardwareSpi;
  Mirf.init();
  Mirf.setTADDR((byte *)"clie1");
  Mirf.setRADDR((byte *)"serv1");  
  Mirf.payload = sizeof(unsigned long);
  Mirf.config(); 
  lcd.init();                  // initialize the lcd 
  lcd.backlight();
}

void loop()
{
  int i,n;
  byte rx_data[Mirf.payload]; 
  String outStr="";
  String inStr="";
   if(Serial.available()>0)
  {
    while(Serial.available()>0) 
    {
      char inchar = Serial.read();
      outStr +=(char) inchar;   
      delay(10);                //延时等待数据完全进入接收缓冲区
      n++;                      //计数接收字符的个数，即字符串的长度
    }
    for(i=0;i<n;i++)           //将从串口接收的字符串通过NRF24L01发送出去
    {
       byte tx_data=outStr[i];
       Mirf.send((byte *)&tx_data);  
       while(Mirf.isSending());
       delay(10);
    }
    
    lcd.clear();   //将从串口接收到的字符串显示到LCD1602上
    lcd.setCursor(0,0);
    lcd.print("TX: ");    
    lcd.print(outStr);    
  }
//===============从NRF24L01接收字符串====================
   if(!Mirf.isSending() && Mirf.dataReady())
   {        
     delay(10);//延时，使NRF24L01能够接收整个字符串  
     while(!Mirf.isSending() && Mirf.dataReady())
     {       
       Mirf.getData(rx_data);
       inStr += (char) rx_data[0];
       delay(10);
     } 
     Serial.print("receive:");//将NRF24L01接收到的字符串发送到串口
     Serial.print(inStr);
     Serial.println("");
     
     lcd.clear();//将NRF24L01接收到的字符串显示到液晶显示屏第二行
     lcd.setCursor(0,1);
     lcd.print("RX: ");  
     lcd.print(inStr);  
   }    
}
